/* Code derived from RemoveQuoteResultParts.js of the ESB Samples */
/* All message parts without empty content id are removed         */

function rule()
{

  // We finish if the are only "transformed parts" left
  finished = false;
  
  while (!finished) {

	  partcount = XQMessage.getPartCount();
	  
	  XQ_logInformation("[selectTransformed.js] parts left: " + partcount);
	  
	  // foundone is true only if a part was removed
	  foundone = false;
	  
	  // Use a "for" to index the current number of parts
	  for(i = 0; i < partcount ; i++){
	  
	  	cid = XQMessage.getPart(i).getContentId();
	  	if(cid != null) {
	  	
	  	    XQ_logInformation("[selectTransformed.js] cid: " + cid);
	  	
		  	if(!cid.equals("")){
			  XQMessage.removePart(i);
			  
			  // There are still parts, we have to take another "while"
			  foundone = true;
			  // Exit the "for" because the number of parts has changed
			  break;
			}   
			
		}
		else {
		
		  // A part without cid (null) is no transformed part => remove it
		
		  XQMessage.removePart(i);
		  foundone = true;
		  break; 
		}
	  }
	  
	  // Prevent infinite loops, shouldn't happend but can if a mistake occurs while editing the code above
	  if ((foundone) && cid.equals("")) {
	  
	  	XQ_logInformation("[selectTransformed.js] error condition: only transformed part left without termination, exiting");
	  	finished = true;
	  
	  }
	  
	  // No more parts without cid starting with "transformed" => Exit
	  if (!foundone) {
	     finished = true;
	  }
  }
  
  return null;		
  
}